package org.seasar.doma.it.entity;

/** */
@javax.annotation.Generated(value = { "Doma", "1.36.0-SNAPSHOT" }, date = "2022-09-08T03:50:33.608+0900")
public final class _Person extends org.seasar.doma.jdbc.entity.AbstractEntityType<org.seasar.doma.it.entity.Person> {

    static {
        org.seasar.doma.internal.Artifact.validateVersion("1.36.0-SNAPSHOT");
    }

    private static final _Person __singleton = new _Person();

    /** the employeeId */
    public final org.seasar.doma.jdbc.entity.AssignedIdPropertyType<java.lang.Object, org.seasar.doma.it.entity.Person, java.lang.Integer, java.lang.Object> $employeeId = new org.seasar.doma.jdbc.entity.AssignedIdPropertyType<java.lang.Object, org.seasar.doma.it.entity.Person, java.lang.Integer, java.lang.Object>(org.seasar.doma.it.entity.Person.class, java.lang.Integer.class, org.seasar.doma.wrapper.IntegerWrapper.class, null, null, "employeeId", "EMPLOYEE_ID");

    /** the employeeNo */
    public final org.seasar.doma.jdbc.entity.BasicPropertyType<java.lang.Object, org.seasar.doma.it.entity.Person, java.lang.Integer, java.lang.Object> $employeeNo = new org.seasar.doma.jdbc.entity.BasicPropertyType<java.lang.Object, org.seasar.doma.it.entity.Person, java.lang.Integer, java.lang.Object>(org.seasar.doma.it.entity.Person.class, java.lang.Integer.class, org.seasar.doma.wrapper.IntegerWrapper.class, null, null, "employeeNo", "EMPLOYEE_NO", true, true);

    /** the employeeName */
    public final org.seasar.doma.jdbc.entity.BasicPropertyType<java.lang.Object, org.seasar.doma.it.entity.Person, java.lang.String, java.lang.Object> $employeeName = new org.seasar.doma.jdbc.entity.BasicPropertyType<java.lang.Object, org.seasar.doma.it.entity.Person, java.lang.String, java.lang.Object>(org.seasar.doma.it.entity.Person.class, java.lang.String.class, org.seasar.doma.wrapper.StringWrapper.class, null, null, "employeeName", "EMPLOYEE_NAME", true, true);

    /** the managerId */
    public final org.seasar.doma.jdbc.entity.BasicPropertyType<java.lang.Object, org.seasar.doma.it.entity.Person, java.lang.Integer, java.lang.Object> $managerId = new org.seasar.doma.jdbc.entity.BasicPropertyType<java.lang.Object, org.seasar.doma.it.entity.Person, java.lang.Integer, java.lang.Object>(org.seasar.doma.it.entity.Person.class, java.lang.Integer.class, org.seasar.doma.wrapper.IntegerWrapper.class, null, null, "managerId", "MANAGER_ID", true, true);

    /** the hiredate */
    public final org.seasar.doma.jdbc.entity.BasicPropertyType<java.lang.Object, org.seasar.doma.it.entity.Person, java.sql.Date, java.lang.Object> $hiredate = new org.seasar.doma.jdbc.entity.BasicPropertyType<java.lang.Object, org.seasar.doma.it.entity.Person, java.sql.Date, java.lang.Object>(org.seasar.doma.it.entity.Person.class, java.sql.Date.class, org.seasar.doma.wrapper.DateWrapper.class, null, null, "hiredate", "HIREDATE", true, true);

    /** the salary */
    public final org.seasar.doma.jdbc.entity.BasicPropertyType<java.lang.Object, org.seasar.doma.it.entity.Person, java.math.BigDecimal, org.seasar.doma.it.domain.Salary> $salary = new org.seasar.doma.jdbc.entity.BasicPropertyType<java.lang.Object, org.seasar.doma.it.entity.Person, java.math.BigDecimal, org.seasar.doma.it.domain.Salary>(org.seasar.doma.it.entity.Person.class, java.math.BigDecimal.class, org.seasar.doma.wrapper.BigDecimalWrapper.class, null, org.seasar.doma.it.domain._Salary.getSingletonInternal(), "salary", "SALARY", true, true);

    /** the departmentId */
    public final org.seasar.doma.jdbc.entity.BasicPropertyType<java.lang.Object, org.seasar.doma.it.entity.Person, java.lang.Integer, org.seasar.doma.it.domain.Identity<org.seasar.doma.it.entity.Department>> $departmentId = new org.seasar.doma.jdbc.entity.BasicPropertyType<java.lang.Object, org.seasar.doma.it.entity.Person, java.lang.Integer, org.seasar.doma.it.domain.Identity<org.seasar.doma.it.entity.Department>>(org.seasar.doma.it.entity.Person.class, java.lang.Integer.class, org.seasar.doma.wrapper.IntegerWrapper.class, null, org.seasar.doma.it.domain._Identity.<org.seasar.doma.it.entity.Department>getSingletonInternal(), "departmentId", "DEPARTMENT_ID", true, true);

    /** the addressId */
    public final org.seasar.doma.jdbc.entity.BasicPropertyType<java.lang.Object, org.seasar.doma.it.entity.Person, java.lang.Integer, java.lang.Object> $addressId = new org.seasar.doma.jdbc.entity.BasicPropertyType<java.lang.Object, org.seasar.doma.it.entity.Person, java.lang.Integer, java.lang.Object>(org.seasar.doma.it.entity.Person.class, java.lang.Integer.class, org.seasar.doma.wrapper.IntegerWrapper.class, null, null, "addressId", "ADDRESS_ID", true, true);

    /** the version */
    public final org.seasar.doma.jdbc.entity.VersionPropertyType<java.lang.Object, org.seasar.doma.it.entity.Person, java.lang.Integer, java.lang.Object> $version = new org.seasar.doma.jdbc.entity.VersionPropertyType<java.lang.Object, org.seasar.doma.it.entity.Person, java.lang.Integer, java.lang.Object>(org.seasar.doma.it.entity.Person.class, java.lang.Integer.class, org.seasar.doma.wrapper.IntegerWrapper.class, null, null, "version", "VERSION");

    private final org.seasar.doma.it.entity.PersonListener __listener;

    private final org.seasar.doma.jdbc.entity.NamingType __namingType;

    private final boolean __immutable;

    private final String __catalogName;

    private final String __schemaName;

    private final String __tableName;

    private final String __qualifiedTableName;

    private final String __name;

    private final java.util.List<org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.Person, ?>> __idPropertyTypes;

    private final java.util.List<org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.Person, ?>> __entityPropertyTypes;

    private final java.util.Map<String, org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.Person, ?>> __entityPropertyTypeMap;

    private _Person() {
        __listener = new org.seasar.doma.it.entity.PersonListener();
        __namingType = org.seasar.doma.jdbc.entity.NamingType.SNAKE_UPPER_CASE;
        __immutable = true;
        __name = "Person";
        __catalogName = "";
        __schemaName = "";
        __tableName = "EMPLOYEE";
        __qualifiedTableName = "EMPLOYEE";
        java.util.List<org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.Person, ?>> __idList = new java.util.ArrayList<org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.Person, ?>>();
        java.util.List<org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.Person, ?>> __list = new java.util.ArrayList<org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.Person, ?>>(9);
        java.util.Map<String, org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.Person, ?>> __map = new java.util.HashMap<String, org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.Person, ?>>(9);
        __idList.add($employeeId);
        __list.add($employeeId);
        __map.put("employeeId", $employeeId);
        __list.add($employeeNo);
        __map.put("employeeNo", $employeeNo);
        __list.add($employeeName);
        __map.put("employeeName", $employeeName);
        __list.add($managerId);
        __map.put("managerId", $managerId);
        __list.add($hiredate);
        __map.put("hiredate", $hiredate);
        __list.add($salary);
        __map.put("salary", $salary);
        __list.add($departmentId);
        __map.put("departmentId", $departmentId);
        __list.add($addressId);
        __map.put("addressId", $addressId);
        __list.add($version);
        __map.put("version", $version);
        __idPropertyTypes = java.util.Collections.unmodifiableList(__idList);
        __entityPropertyTypes = java.util.Collections.unmodifiableList(__list);
        __entityPropertyTypeMap = java.util.Collections.unmodifiableMap(__map);
    }

    @Override
    public org.seasar.doma.jdbc.entity.NamingType getNamingType() {
        return __namingType;
    }

    @Override
    public boolean isImmutable() {
        return __immutable;
    }

    @Override
    public String getName() {
        return __name;
    }

    @Override
    public String getCatalogName() {
        return __catalogName;
    }

    @Override
    public String getSchemaName() {
        return __schemaName;
    }

    @Override
    public String getTableName() {
        return __tableName;
    }

    @Override
    public String getQualifiedTableName() {
        return __qualifiedTableName;
    }

    @Override
    public void preInsert(org.seasar.doma.it.entity.Person entity, org.seasar.doma.jdbc.entity.PreInsertContext<org.seasar.doma.it.entity.Person> context) {
        __listener.preInsert(entity, context);
    }

    @Override
    public void preUpdate(org.seasar.doma.it.entity.Person entity, org.seasar.doma.jdbc.entity.PreUpdateContext<org.seasar.doma.it.entity.Person> context) {
        __listener.preUpdate(entity, context);
    }

    @Override
    public void preDelete(org.seasar.doma.it.entity.Person entity, org.seasar.doma.jdbc.entity.PreDeleteContext<org.seasar.doma.it.entity.Person> context) {
        __listener.preDelete(entity, context);
    }

    @Override
    public void postInsert(org.seasar.doma.it.entity.Person entity, org.seasar.doma.jdbc.entity.PostInsertContext<org.seasar.doma.it.entity.Person> context) {
        __listener.postInsert(entity, context);
    }

    @Override
    public void postUpdate(org.seasar.doma.it.entity.Person entity, org.seasar.doma.jdbc.entity.PostUpdateContext<org.seasar.doma.it.entity.Person> context) {
        __listener.postUpdate(entity, context);
    }

    @Override
    public void postDelete(org.seasar.doma.it.entity.Person entity, org.seasar.doma.jdbc.entity.PostDeleteContext<org.seasar.doma.it.entity.Person> context) {
        __listener.postDelete(entity, context);
    }

    @Override
    public java.util.List<org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.Person, ?>> getEntityPropertyTypes() {
        return __entityPropertyTypes;
    }

    @Override
    public org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.Person, ?> getEntityPropertyType(String __name) {
        return __entityPropertyTypeMap.get(__name);
    }

    @Override
    public java.util.List<org.seasar.doma.jdbc.entity.EntityPropertyType<org.seasar.doma.it.entity.Person, ?>> getIdPropertyTypes() {
        return __idPropertyTypes;
    }

    @Override
    public org.seasar.doma.jdbc.entity.GeneratedIdPropertyType<java.lang.Object, org.seasar.doma.it.entity.Person, ?, ?> getGeneratedIdPropertyType() {
        return null;
    }

    @Override
    public org.seasar.doma.jdbc.entity.VersionPropertyType<java.lang.Object, org.seasar.doma.it.entity.Person, ?, ?> getVersionPropertyType() {
        return $version;
    }

    @Override
    public org.seasar.doma.it.entity.Person newEntity() {
        return null;
    }

    @SuppressWarnings("unchecked")
    @Override
    public org.seasar.doma.it.entity.Person newEntity(java.util.Map<String, Object> __args) {
        return new org.seasar.doma.it.entity.Person(
            (java.lang.Integer)__args.get("employeeId"),
            (java.lang.Integer)__args.get("employeeNo"),
            (java.lang.String)__args.get("employeeName"),
            (java.lang.Integer)__args.get("managerId"),
            (java.sql.Date)__args.get("hiredate"),
            (org.seasar.doma.it.domain.Salary)__args.get("salary"),
            (org.seasar.doma.it.domain.Identity<org.seasar.doma.it.entity.Department>)__args.get("departmentId"),
            (java.lang.Integer)__args.get("addressId"),
            (java.lang.Integer)__args.get("version"));
    }

    @Override
    public Class<org.seasar.doma.it.entity.Person> getEntityClass() {
        return org.seasar.doma.it.entity.Person.class;
    }

    @Override
    public org.seasar.doma.it.entity.Person getOriginalStates(org.seasar.doma.it.entity.Person __entity) {
        return null;
    }

    @Override
    public void saveCurrentStates(org.seasar.doma.it.entity.Person __entity) {
    }

    /**
     * @return the singleton
     */
    public static _Person getSingletonInternal() {
        return __singleton;
    }

    /**
     * @return the new instance
     */
    public static _Person newInstance() {
        return new _Person();
    }

}
